Implement --tweak, --no-tweak, --no-tweak-hlinked options.
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
6f481bb0 21tmpdir="$scratchdir"
e3442095
WD
22fromdir="$tmpdir/from"
23todir="$tmpdir/to"
24chkdir="$tmpdir/chk"
3a4c683f 25
fc29efc3
WD
26# For itemized output:
27all_plus='+++++++++'
28allspace=' '
29dots='.....' # trailing dots after changes
30
2094283b 31# Berkley's nice.
96553aa7 32PATH="$PATH:/usr/ucb"
2094283b 33
e3442095 34if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
35 diffopt="-u"
36else
37 diffopt="-c"
38fi
39
a98cad00
WD
40HOME="$scratchdir"
41export HOME
42
3a4c683f
MP
43runtest() {
44 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
45 if eval "$2"
46 then
6f481bb0 47 echo "$ECHO_T done."
501972bf
MP
48 return 0
49 else
6f481bb0 50 echo "$ECHO_T failed!"
501972bf
MP
51 return 1
52 fi
3a4c683f
MP
53}
54
757287d8
WD
55# Call this if you want to filter out verbose messages (-v or -vv) from
56# the output of an rsync run (whittling the output down to just the file
57# messages). This isn't needed if you use -i without -v.
58filter_outfile() {
59 sed -e '/^building file list /d' \
9544261a 60 -e '/^sending incremental file list/d' \
757287d8
WD
61 -e '/^created directory /d' \
62 -e '/^done$/d' \
63 -e '/ --whole-file$/d' \
64 -e '/^total: /d' \
332cf6df
WD
65 -e '/^client charset: /d' \
66 -e '/^server charset: /d' \
757287d8
WD
67 -e '/^$/,$d' \
68 <"$outfile" >"$outfile.new"
69 mv "$outfile.new" "$outfile"
70}
71
3a4c683f
MP
72printmsg() {
73 echo "$1"
74}
75
6773a779 76rsync_ls_lR() {
db9c9e27 77 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
dfef3f10
MP
78}
79
18d7e9f4 80check_perms() {
7359a58b 81 perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-dlp]\(.........\).*/\1/'`
eace352b
WD
82 if test $perms = $2; then
83 return 0
84 fi
85 echo "permissions: $perms on $1"
86 echo "should be: $2"
87 test_fail "failed test $3"
18d7e9f4
WD
88}
89
dfef3f10
MP
90rsync_getgroups() {
91 "$TOOLDIR/getgroups"
57835c00
MP
92}
93
7359a58b
MM
94confile=`echo "$scratchdir" | sed 's;/testtmp/[^/]*$;/config.h;'`
95config_test() {
96 egrep "^#define $1 1" "$confile" >/dev/null
97}
57835c00 98
e052b21f 99####################
6f481bb0 100# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 101
3a4c683f 102hands_setup() {
501972bf 103 # Clean before creation
6f481bb0
WD
104 rm -rf "$fromdir"
105 rm -rf "$todir"
3d807132 106
e3442095
WD
107 [ -d "$tmpdir" ] || mkdir "$tmpdir"
108 [ -d "$fromdir" ] || mkdir "$fromdir"
109 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 110
e052b21f
MP
111 # On some BSD systems, the umask affects the mode of created
112 # symlinks, even though the mode apparently has no effect on how
113 # the links behave in the future, and it cannot be changed using
114 # chmod! rsync always sets its umask to 000 so that it can
115 # accurately recreate permissions, but this script is probably run
116 # with a different umask.
117
118 # This causes a little problem that "ls -l" of the two will not be
119 # the same. So, we need to set our umask before doing any creations.
120
3a4c683f 121 # set up test data
6f481bb0
WD
122 touch "$fromdir/empty"
123 mkdir "$fromdir/emptydir"
e8ca5901 124
571a4b26 125 # a hundred lines of text or so
6f481bb0 126 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 127
6f481bb0 128 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 129 umask 0
6f481bb0 130 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 131 umask 022
0154b302 132
db10766a 133 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
134 mkdir "$fromdir/dir"
135 cp "$fromdir/text" "$fromdir/dir"
136 mkdir "$fromdir/dir/subdir"
137 echo some data > "$fromdir/dir/subdir/foobar.baz"
138 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
139 if [ -r /etc ]; then
140 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
141 else
142 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
143 fi
6f481bb0 144 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
145 if [ -r /bin ]; then
146 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
147 else
148 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
149 fi
7d691654 150
8f98c608 151# echo testing head:
6f481bb0 152# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 153}
3fedd74b
MP
154
155
99cdaff7
MP
156####################
157# Many machines do not have "mkdir -p", so we have to build up long paths.
158# How boring.
5ef8c5c6 159makepath() {
d1798a2f
WD
160 for p in "${@}"; do
161 (echo " makepath $p"
162
99cdaff7
MP
163 # Absolut Unix.
164 if echo $p | grep '^/' >/dev/null
165 then
166 cd /
167 fi
168
d1798a2f 169 # This will break if $p contains a space.
99cdaff7
MP
170 for c in `echo $p | tr '/' ' '`
171 do
112e7311
MP
172 if [ -d "$c" ] || mkdir "$c"
173 then
174 cd "$c" || return $?
175 else
176 echo "failed to create $c" >&2; return $?
177 fi
d1798a2f
WD
178 done)
179 done
99cdaff7
MP
180}
181
182
183
3fedd74b
MP
184###########################
185# Run a test (in '$1') then compare directories $2 and $3 to see if
186# there are any difference. If there are, explain them.
187
f494f286
MP
188# So normally basically $1 should be an rsync command, and $2 and $3
189# the source and destination directories. This is only good when you
190# expect to transfer the whole directory exactly as is. If some files
191# should be excluded, you might need to use something else.
192
3fedd74b 193checkit() {
3fedd74b 194 failed=
3fedd74b 195
cf72f204
MP
196 # We can just write everything to stdout/stderr, because the
197 # wrapper hides it unless there is a problem.
198
199 echo "Running: \"$1\""
200 eval "$1"
3fedd74b
MP
201 status=$?
202 if [ $status != 0 ]; then
203 failed="YES";
204 fi
205
cf72f204
MP
206 echo "-------------"
207 echo "check how the directory listings compare with diff:"
208 echo ""
6f481bb0
WD
209 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
210 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
211 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
30688bf1
WD
212
213 echo "-------------"
214 echo "check how the files compare with diff:"
215 echo ""
216 if [ "x$4" != x ]; then
217 echo " === Skipping (as directed) ==="
218 else
219 diff -r $diffopt "$2" "$3" || failed=YES
220 fi
221
222 echo "-------------"
6f481bb0 223 if [ -z "$failed" ] ; then
3fedd74b
MP
224 return 0
225 else
3fedd74b
MP
226 return 1
227 fi
228}
229
863dff51 230
4a7cb3e8 231build_rsyncd_conf() {
d2094cc3
MP
232 # Build an appropriate configuration file
233 conf="$scratchdir/test-rsyncd.conf"
234 echo "building configuration $conf"
235
236 port=2612
237 pidfile="$scratchdir/rsyncd.pid"
238 logfile="$scratchdir/rsyncd.log"
e5255195 239 hostname=`uname -n`
d2094cc3 240
6f481bb0 241 cat >"$conf" <<EOF
3aae15ec 242# rsyncd configuration file autogenerated by $0
d2094cc3 243
3aae15ec
MP
244pid file = $pidfile
245use chroot = no
9585b276 246munge symlinks = no
e73eed85 247hosts allow = localhost 127.0.0.0/24 192.168.0.0/16 10.0.0.0/8 $hostname
3aae15ec 248log file = $logfile
2ae4126a
WD
249log format = %i %h [%a] %m (%u) %l %f%L
250transfer logging = yes
6f481bb0 251exclude = foobar.baz
eddeaf76 252max verbosity = 9
76ee1d18
WD
253uid = 0
254gid = 0
98c1b325 255
2e6c7f45 256[test-from]
6f481bb0 257 path = $fromdir
3aae15ec 258 read only = yes
d2094cc3 259
2e6c7f45 260[test-to]
6f481bb0 261 path = $todir
3aae15ec 262 read only = no
2ae4126a
WD
263
264[test-scratch]
265 path = $scratchdir
266 read only = no
d2094cc3 267EOF
2d8f9b1d
WD
268
269 # Build a helper script to ignore exit code 23
270 ignore23="$scratchdir/ignore23"
271 echo "building help script $ignore23"
272
273 cat >"$ignore23" <<'EOT'
274if "${@}"; then
275 exit
276fi
277
278ret=$?
279
280if test $ret = 23; then
281 exit
282fi
283
284exit $ret
285EOT
286chmod +x "$ignore23"
d2094cc3
MP
287}
288
289
3cd2af41 290build_symlinks() {
3cd2af41
MP
291 mkdir "$fromdir"
292 date >"$fromdir/referent"
293 ln -s referent "$fromdir/relative"
294 ln -s "$fromdir/referent" "$fromdir/absolute"
295 ln -s nonexistent "$fromdir/dangling"
1db8b61d 296 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
297}
298
299test_fail() {
300 echo "$@" >&2
301 exit 1
302}
303
a217ad30
MP
304test_skipped() {
305 echo "$@" >&2
6f481bb0 306 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
307 exit 77
308}
309
be2f866b
MP
310# It failed, but we expected that. don't dump out error logs,
311# because most users won't want to see them. But do leave
312# the working directory around.
313test_xfail() {
314 echo "$@" >&2
315 exit 78
316}
317
d1239eae
MP
318# Determine what shell command will appropriately test for links.
319ln -s foo "$scratchdir/testlink"
320for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
321do
322 for switch in -h -L
323 do
324 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
325 then
326 # how nice
327 TEST_SYMLINK_CMD="$cmd $switch"
328 # i wonder if break 2 is portable?
329 break 2
330 fi
331 done
332done
cca4e067
MP
333# ok, now get rid of it
334rm "$scratchdir/testlink"
d1239eae
MP
335
336
337if [ "x$TEST_SYMLINK_CMD" = 'x' ]
338then
339 test_fail "Couldn't determine how to test for symlinks"
340else
341 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
342fi
343
344
d96d3893
MP
345# Test whether something is a link, allowing for shell peculiarities
346is_a_link() {
d1239eae
MP
347 # note the variable contains the first option and therefore is not quoted
348 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
349}
350
77867907
MP
351
352# We need to set the umask to be reproducible. Note also that when we
353# do some daemon tests as root, we will setuid() and therefore the
354# directory has to be writable by the nobody user in some cases. The
355# best thing is probably to explicitly chmod those directories after
356# creation.
357
ad301e48 358umask 022